Troubleshooting & FAQs
Use Cases
Following are some specific cases whose integration is handled on a case-by-case basis:Donations
Donations
WebView
WebView
Network Connectivity Issues
Network Connectivity Issues
Build Integration
A to-do-list for integration is given below:Clone the Razorpay Sample Application in Your Language and Test the Payment Flow.
Clone the Razorpay Sample Application in Your Language and Test the Payment Flow.
Integrate with Orders API on the Server Side.
Integrate with Orders API on the Server Side.
- An order should be created for every payment.
- You can create an order using the Orders API. It is a server-side API call. Know how to authenticate Orders API.
- The
order_idreceived in the response should be passed to the checkout. This ties the order with the payment and secures the request from being tampered.
- Using the sample code on the Razorpay Postman Public Workspace.
- By manually integrating the API sample codes on your server.
Razorpay Postman Public Workspace
You can use the Postman workspace below to create an order:API Sample Code
Use this endpoint to create an order using the Orders API.POST /ordersRequest Parameters
Request Parameters
amount mandatory
: integer Payment amount in the smallest currency subunit. For example, if the amount to be charged is ₹299, then pass 29900 in this field. In the case of three decimal currencies, such as KWD, BHD and OMR, to accept a payment of 295.991, pass the value as 295990. And in the case of zero decimal currencies such as JPY, to accept a payment of 295, pass the value as 295.currency mandatory
: string The currency in which the transaction should be made. See the list of supported currencies. Length must be 3 characters.receipt optional
: string Your receipt id for this order should be passed here. Maximum length is 40 characters.notes optional
: json object Key-value pair that can be used to store additional information about the entity. Maximum 15 key-value pairs, 256 characters (maximum) each. For example, "note_key": "Beam me up Scotty”.partial_payment optional
: boolean Indicates whether the customer can make a partial payment. Possible values:true: The customer can make partial payments.false(default): The customer cannot make partial payments.
first_payment_min_amount optional
: integer Minimum amount that must be paid by the customer as the first partial payment. For example, if an amount of ₹7000 is to be received from the customer in two installments of #1 - ₹5000, #2 - ₹2000 then you can set this value as 500000. This parameter should be passed only if partial_payment is true.Know more about Orders API.Response Parameters
Response Parameters
Error Response Parameters
Error Response Parameters
Success Callback
Success Callback
- You need to store these fields in your server.
- You can confirm the authenticity of these details by verifying the signature in the next step.
razorpay_payment_id
: string Unique identifier for the payment returned by Checkout only for successful payments.razorpay_order_id
: string Unique identifier for the order returned by Checkout.razorpay_signature
: string Signature returned by the Checkout. This is used to verify the payment.Test Heading
Therazorpay_order_id, returned on successful creation of the order, should be sent to the Checkout form. Additionally, you need to send an extra key-value pair as shown:razorpay_order_id, razorpay_payment_id and razorpay_signature, which is then used for payment verification.Display the Checkout Form on Your Website to Your Customer.
Display the Checkout Form on Your Website to Your Customer.
order_id option is passed along with the other checkout options mentioned below.key mandatory
: string API Key ID generated from the Dashboard.amount mandatory
: integer Payment amount in the smallest currency subunit. For example, if the amount to be charged is , enter 222250 in this field. In the case of three decimal currencies, such as KWD, BHD and OMR, to accept a payment of 295.991, pass the value as 295990. And in the case of zero decimal currencies such as JPY, to accept a payment of 295, pass the value as 295.currency mandatory
: string The currency in which the payment should be made by the customer. See the list of supported currencies.name mandatory
: string Your Business/Enterprise name shown on the Checkout form. For example, Acme Corp.description optional
: string Description of the purchase item shown on the Checkout form. It should start with an alphanumeric character.image optional
: string Link to an image (usually your business logo) shown on the Checkout form. Can also be a base64 string if you are not loading the image from a network.order_id mandatory
: string Order ID generated via Orders API.prefill
: object You can prefill the following details at Checkout.- Autofill customer contact details, especially phone number to ease form completion. Include customer’s phone number in the
contactparameter of the JSON request’sprefillobject. Format: +(country code)(phone number). Example: “contact”: “+919000090000”. - This is not applicable if you do not collect customer contact details on your website before checkout, have Shopify stores or use any of the no-code apps.
name optional
: string Cardholder’s name to be prefilled if customer is to make card payments on Checkout. For example, Gaurav Kumar.email optional
: string Email address of the customer.contact optional
: string Phone number of the customer. The expected format of the phone number is + {country code}{phone number}. If the country code is not specified, 91 will be used as the default value. This is particularly important while prefilling contact of customers with phone numbers issued outside India. Examples:- +14155552671 (a valid non-Indian number)
- +919977665544 (a valid Indian number).
If 9977665544 is entered,+91is added to it as +919977665544.
method optional
: string Pre-selection of the payment method for the customer. Will only work if contact and email are also prefilled. Possible values:cardnetbankingwalletupiemi
notes optional
: object Set of key-value pairs that can be used to store additional information about the payment. It can hold a maximum of 15 key-value pairs, each 256 characters long (maximum).theme
: object Thematic options to modify the appearance of Checkout.color optional
: string Enter your brand colour’s HEX code to alter the text, payment method icons and CTA (call-to-action) button colour of the Checkout form.backdrop_color optional
: string Enter a HEX code to change the Checkout’s backdrop colour.modal
: object Options to handle the Checkout modal.backdropclose optional
: boolean Indicates whether clicking the translucent blank space outside the Checkout form should close the form. Possible values:true: Closes the form when your customer clicks outside the checkout form.false(default): Does not close the form when customer clicks outside the checkout form.
escape optional
: boolean Indicates whether pressing the escape key should close the Checkout form. Possible values:true(default): Closes the form when the customer presses the escape key.false: Does not close the form when the customer presses the escape key.
handleback optional
: boolean Determines whether Checkout must behave similar to the browser when back button is pressed. Possible values:true(default): Checkout behaves similarly to the browser. That is, when the browser’s back button is pressed, the Checkout also simulates a back press. This happens as long as the Checkout modal is open.false: Checkout does not simulate a back press when browser’s back button is pressed.
confirm_close optional
: boolean Determines whether a confirmation dialog box should be shown if customers attempts to close Checkout. Possible values:true: Confirmation dialog box is shown.false(default): Confirmation dialog box is not shown.
ondismiss optional
: function Used to track the status of Checkout. You can pass a modal object with ondismiss: function()\{\} as options. This function is called when the modal is closed by the user. If retry is false, the ondismiss function is triggered when checkout closes, even after a failure.animation optional
: boolean Shows an animation before loading of Checkout. Possible values:true(default): Animation appears.false: Animation does not appear.
subscription_id optional
: string If you are accepting recurring payments using Razorpay Checkout, you should pass the relevant subscription_id to the Checkout. Know more about Subscriptions on Checkout.subscription_card_change optional
: boolean Permit or restrict customer from changing the card linked to the subscription. You can also do this from the hosted page. Possible values:true: Allow the customer to change the card from Checkout.false(default): Do not allow the customer to change the card from Checkout.
recurring optional
: boolean Determines if you are accepting recurring (charge-at-will) payments on Checkout via instruments such as emandate, paper NACH and so on. Possible values:true: You are accepting recurring payments.false(default): You are not accepting recurring payments.
callback_url optional
: string Customers will be redirected to this URL on successful payment. Ensure that the domain of the Callback URL is allowlisted.redirect optional
: boolean Determines whether to post a response to the event handler post payment completion or redirect to Callback URL. callback_url must be passed while using this parameter. Possible values:true: Customer is redirected to the specified callback URL in case of payment failure.false(default): Customer is shown the Checkout popup to retry the payment with the suggested next best option.
customer_id optional
: string Unique identifier of customer. Used for:- Local saved cards feature.
- Static bank account details on Checkout in case of Bank Transfer payment method.
remember_customer optional
: boolean Determines whether to allow saving of cards. Can also be configured via the Dashboard. Possible values:true: Enables card saving feature.false(default): Disables card saving feature.
timeout optional
: integer Sets a timeout on Checkout, in seconds. After the specified time limit, the customer will not be able to use Checkout.readonly
: object Marks fields as read-only.contact optional
: boolean Used to set the contact field as readonly. Possible values:true: Customer will not be able to edit this field.false(default): Customer will be able to edit this field.
email optional
: boolean Used to set the email field as readonly. Possible values:true: Customer will not be able to edit this field.false(default): Customer will be able to edit this field.
name optional
: boolean Used to set the name field as readonly. Possible values:true: Customer will not be able to edit this field.false(default): Customer will be able to edit this field.
hidden
: object Hides the contact details.contact optional
: boolean Used to set the contact field as optional. Possible values:true: Customer will not be able to view this field.false(default): Customer will be able to view this field.
email optional
: boolean Used to set the email field as optional. Possible values:true: Customer will not be able to view this field.false(default): Customer will be able to view this field.
send_sms_hash optional
: boolean Used to auto-read OTP for cards and netbanking pages. Applicable from Android SDK version 1.5.9 and above. Possible values:true: OTP is auto-read.false(default): OTP is not auto-read.
allow_rotation optional
: boolean Used to rotate payment page as per screen orientation. Applicable from Android SDK version 1.6.4 and above. Possible values:true: Payment page can be rotated.false(default): Payment page cannot be rotated.
retry optional
: object Parameters that enable retry of payment on the checkout.enabled
: boolean Determines whether the customers can retry payments on the checkout. Possible values:true(default): Enables customers to retry payments.false: Disables customers from retrying the payment.
max_count
: integer The number of times the customer can retry the payment. We recommend you to set this to 4. Having a larger number here can cause loops to occur.config optional
: object Parameters that enable checkout configuration. Know more about how to configure payment methods on Razorpay standard checkout.display
: object Child parameter that enables configuration of checkout display language.language
: string The language in which checkout should be displayed. Possible values:en: Englishben: Bengalihi: Hindimar: Marathiguj: Gujaratitam: Tamiltel: Telugu
Verify the Signature Post Checkout Form Submission.
Verify the Signature Post Checkout Form Submission.
To verify the `razorpay_signature` returned to you by the Checkout form:
To verify the `razorpay_signature` returned to you by the Checkout form:
-
Create a signature in your server using the following attributes:
order_id: Retrieve theorder_idfrom your server. Do not use therazorpay_order_idreturned by Checkout.razorpay_payment_id: Returned by Checkout.key_secret: Available in your server. Thekey_secretthat was generated from the Dashboard.
-
Use the SHA256 algorithm, the
razorpay_payment_idand theorder_idto construct a HMAC hex digest as shown below:
- If the signature you generate on your server matches the
razorpay_signaturereturned to you by the Checkout form, the payment received is from an authentic source.
Generate Signature on Your Server
Generate Signature on Your Server
Post Signature Verification
Post Signature Verification
Display the Confirmation Message to the Customer.
Display the Confirmation Message to the Customer.
payment successful message to the customer.Mark the Platform Order as Successful.
Mark the Platform Order as Successful.
razorpay_order_id in your database. You can now mark this fetched order as successful and process the order.You can make a test payment to check whether the integration works.Common Issues Faced During Integration
Following are some of the common issues that you must watch out for while integrating:- Not storing the Razorpay order ID at your end.
- Passing the amount from the frontend to the Razorpay order creation call.
- Passing
USDor any othernon-SGDcurrency while creating the order. - Passing
razorpay_order_idfrom the frontend while verifying the signature.